/***************************************************************************
 *   Copyright (C) 2003-2007 by Spiros Georgaras <sng@hellug.gr>           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.         *
 ***************************************************************************/
#include "iconload.h"
#include <kurllabel.h>
#include <krun.h>
#include <qsize.h>
#include <kaboutdata.h>
#include <kdeversion.h>
#include <klocale.h>
#include <ktextbrowser.h> 
#include <fabout.h>
//#define DO_NOT_TRANSLATE
extern KAboutData * ab;
extern iconload ic;
void fAbout::init(){
	setIcon(ic.Icon(9));
	pixmapLabel1->setPixmap(ic.Icon(9));
	setCaption(QString(i18n("About %1")).arg("GwenRename"));
// 	shortDescription->setText(ab->shortDescription());
// 	acLabel->setText(ab->shortDescription()+acLabel.text());
	QString cop="\n"+ab->copyrightStatement();
	lblC->setText(cop);
	QString t=QString(i18n("%1 %2 (Using KDE %3)")).arg("GwenRename").arg(ab->version()).arg(KDE_VERSION_STRING);
	t.prepend("<b><nobr>");t+="</nobr></b>";
	lblVersion->setText(t);
	lblVersion->setScaledContents(TRUE);
	t="<p><b>Aurelien Gateau</b><br>";
	t+=i18n("For all the help he's offered");
	t+="</p><p><b>Jan Schubert</b><br>";
	t+=i18n("For giving me the idea to use timestamping information to GwenRename, and providing Exif images for testing.");
	t+="</p><p><b>Charles Barcza</b><br>";
	t+=i18n("For the help he offered debuging v 0.9.9.");	 
	t+="</p><p><b>Sidlovsky Yaroslav</b><br>";
	t+=i18n("For the help he offered debuging v 1.0.0 and creating the new pot file.");
	t+="</p><p><b>Gerardo Bueno</b><br><b>Gunther Zilz</b><br>";
	t+=i18n("For helping me debug the icons installation problem in version 1.1.-beta1 and beta2.");
	thanks->setText(t);
	gURL->setURL(ab->homepage());
	gURL->setText(ab->homepage());
	buttonClose->setText( i18n( "&Close" ) );
	buttonClose->setAccel( QKeySequence( "Alt+C"));
	license->setText(ab->license());
	license->setPaletteBackgroundColor(tabWidget2->paletteBackgroundColor());
	thanks->setPaletteBackgroundColor(tabWidget2->paletteBackgroundColor());
	KConfigBase *config = KGlobal::config();
	config->setGroup("Locale");
	QString lang=config->readEntry("Language"); 
	if(lang!=QString::null && lang.find("en",0)!=0){
		TabPage = new QWidget( tabWidget2, "TabPage" );
		TabPageLayout = new QHBoxLayout( TabPage, 5, 6, "TabPageLayout"); 
		KTextBrowser* trans;
		trans = new KTextBrowser( TabPage, "trans" );
		trans->setWordWrap( KTextBrowser::FixedColumnWidth );
		trans->setWrapColumnOrWidth( 40 );
		TabPageLayout->addWidget( trans );
		tabWidget2->insertTab( TabPage, QString(""),2 );
		QValueList< KAboutTranslator > v=ab->translators();
		if(KDE_VERSION_MINOR==1) trans->setPaletteBackgroundColor(tabWidget2->paletteBackgroundColor());
		else trans->setWordWrap(KTextBrowser::WidgetWidth);
		tabWidget2->changeTab( TabPage, i18n( "T&ranslation" ) );
		if(v.empty()){
			if(KDE_VERSION_MINOR==1) trans->setWrapColumnOrWidth( 120 );
// 	    #ifdef DO_NOT_TRANSLATE
// 	    t="<p>There is no translation available for your language.</p>";
// 	    #else
			t="<p>There is no translation available for your language.<p><p>If you would like to translate the program please contact your KDE <a href=\"http://l10n.kde.org/teams-list.php\">translation team</a>.<br>GwenRename resides in KDE SVN, module <b>playground-utils</b></p><p>If no translation team exists for your language, feel free to translate it yourself.<br>When you are done, <a href=\"mailto:sng@hellug.gr?subject=New translation for GwenRename\">send me</a> the resulting po file and I will add a link to the <a href=\"http://members.hellug.gr//sng//gwenrename//download.html\">download page</a> of GwenRename site. </p><p>Your translation will be included in the next GwenRename release.<p><p>For more information on traslating KDE programs, please visit the <a href=\"http://l10n.kde.org//\">KDE Internationalization</a> site.</p>";
// 	    #endif
		}else{
			KAboutTranslator kAbTr;
			t="";
			for(uint i=0;i<v.count();i++){
				kAbTr=v[i];
		//t+=QString("<p>&nbsp;&nbsp;%1<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"mailto:%2\">%3</a></p>").arg(kAbTr.name(),kAbTr.emailAddress(),kAbTr.emailAddress());
				t+=QString("<p>&nbsp;&nbsp;%1<br>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href=\"mailto:%2\">%3</a></p>").arg(kAbTr.name()).arg(kAbTr.emailAddress()).arg(kAbTr.emailAddress());
			}
			t+=ab->aboutTranslationTeam();
		}
		trans->setText(t);
	}
	buttonClose->setFocus();
}

void fAbout::destroy(){}


void fAbout::gURLClicked( const QString &op ){
	KRun opBr(op);
	opBr.runURL(op,"text/html",FALSE);
}

